﻿

Public Class ClassGeodib
    Private Structure Rect
        Public Left As Long
        Public Top As Long
        Public Right As Long
        Public Bottom As Long
    End Structure
    Private Structure BITMAPFILEHEADER
        Public bfType As Integer
        Public bfSize As Long
        Public bfReserved1 As Integer
        Public bfReserved2 As Integer
        Public bfOffBits As Long
    End Structure
    Public Structure BITMAPINFOHEADER
        Public biSize As Long
        Public biWidth As Long
        Public biHeight As Long
        Public biPlanes As Integer
        Public biBitCount As Integer
        Public biCompression As Long
        Public biSizeImage As Long
        Public biXPelsPerMeter As Long
        Public biYPelsPerMeter As Long
        Public biClrUsed As Long
        Public biClrImportant As Long
    End Structure

    Public Structure RGBQUAD
        Public rgbBlue As Byte
        Public rgbGreen As Byte
        Public rgbRed As Byte
        Public rgbReserved As Byte
    End Structure

    Public Structure BITMAPINFO
        Public bmiHeader As BITMAPINFOHEADER
        Public bmiColors() As RGBQUAD
    End Structure

    Private Const BI_RGB = 0&
    Private Const CBM_INIT = &H4
    Private Const DIB_RGB_COLORS = 0
    Private Const SRCCOPY = &HCC0020
    Private Const SRCAND = &H8800C6
    Private Const STRETCH_DELETESCANS& = 3
    Private Const STRETCH_ANDSCANS& = 1

    Private Declare Function GlobalAlloc& Lib "kernel32" (ByVal wFlags As Integer, ByVal dwBytes As Integer)
    Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal lpvDest As Integer, ByVal lpvSource As Integer, ByVal cbCopy As Integer)
    Private Declare Sub FillMemory Lib "kernel32" Alias "RtlFillMemory" (ByVal lpvDest As Integer, ByVal lpSize As Integer, ByVal lpvalue As Byte)
    Private Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer, ByVal dx As Integer, ByVal dy As Integer, ByVal SrcX As Integer, ByVal SrcY As Integer, ByVal wSrcWidth As Integer, ByVal wSrcHeight As Integer, ByVal lpBits As Integer, ByVal lpBitsInfo As BITMAPINFO, ByVal wUsage As Integer, ByVal dwRop As Integer) As Integer
    Private Declare Function GlobalLock& Lib "kernel32" (ByVal hMem As Integer)
    Private Declare Function GlobalUnlock& Lib "kernel32" (ByVal hMem As Integer)
    Private Declare Function SetStretchBltMode& Lib "gdi32" (ByVal hdc As Integer, ByVal nStretchMode As Integer)
    Private Declare Function GlobalFree& Lib "kernel32" (ByVal hMem As Integer)
    Private Declare Function GlobalReAlloc& Lib "kernel32" (ByVal hMem As Integer, ByVal dwBytes As Integer, ByVal wFlags As Integer)
    Private Declare Function GlobalSize& Lib "kernel32" (ByVal hMem As Integer)


    Public Sub New()

    End Sub

    Public Sub test(ByVal g As Graphics)

        Dim bitm As New Bitmap("C:\test.tif")
        'g.DrawImage(bitm, 0, 0)
        Dim r As System.Drawing.Rectangle
        r = New Rectangle(0, 0, bitm.Width, bitm.Height)
        Dim bd As System.Drawing.Imaging.BitmapData = bitm.LockBits(r, Imaging.ImageLockMode.ReadOnly, Imaging.PixelFormat.Format1bppIndexed)
        Dim ptr As IntPtr = bd.Scan0
        Dim bytes As Integer = bd.Stride * bd.Height
        Dim lpdata(bytes - 1) As Byte

        System.Runtime.InteropServices.Marshal.Copy(ptr, lpdata, 0, bytes)

        'Dim B As IntPtr = bitm.GetHbitmap
    End Sub


End Class
